SystemOrganization addCategory: #PacMan!

Object subclass: #ActorMovements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!ActorMovements methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 21:12'!
nextPositionFrom: anActorPosition going: aPoint through: aCellType 
	^self subclassResponsibility.! !

ActorMovements subclass: #GhostMovements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostMovements methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:41'!
nextPositionFrom: anActorPosition going: aPoint through: aCellType 
	^aCellType nextPositionForGhostFrom: anActorPosition going: aPoint.! !

ActorMovements subclass: #PacmanMovements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacmanMovements methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:49'!
nextPositionFrom: anActorPosition going: aPoint through: aCellType 
	^aCellType nextPositionForPacmanFrom:  anActorPosition going: aPoint.! !

Object subclass: #CellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!CellType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:51'!
nextPositionFor: anActor going: aPoint 
	^anActor movement nextPositionFrom: anActor position going: aPoint through: self.
	
	! !

!CellType methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:48'!
nextPositionForGhostFrom: anActorPosition going: aPoint 
	^self subclassResponsibility.
! !

!CellType methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:48'!
nextPositionForPacmanFrom: anActorPosition going: aPoint 
	^self subclassResponsibility.
! !

CellType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:50'!
nextPositionForGhostFrom: anActorPosition going: aPoint 
	^anActorPosition+aPoint.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:50'!
nextPositionForPacmanFrom: anActorPosition going: aPoint
	^anActorPosition.! !

CellType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:41'!
nextPositionForGhostFrom: anActorPosition going: aPoint 
	^anActorPosition.! !

!LeftTransporterType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:48'!
nextPositionForPacmanFrom: anActorPosition going: aPoint
	^3@10.! !

CellType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:52'!
nextPositionForGhostFrom: anActorPosition going: aPoint 
	^anActorPosition + aPoint.! !

!SpaceType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:52'!
nextPositionForPacmanFrom: anActorPosition going: aPoint 
	^anActorPosition + aPoint.! !

CellType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:52'!
nextPositionForGhostFrom: anActorPosition going: aPoint 
	^anActorPosition.! !

!WallType methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:53'!
nextPositionForPacmanFrom: anActorPosition going: aPoint 
	^anActorPosition.! !

Object subclass: #PacManGameActors
	instanceVariableNames: 'myMovement myPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PacManGameActors subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:59'!
initialize
	myMovement:= GhostMovements new.
	myPosition:= 10@0.! !

PacManGameActors subclass: #PacMan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacMan methodsFor: 'accessing' stamp: 'Pablo 5/16/2012 20:59'!
initialize
	myMovement:= PacmanMovements new.
	myPosition:= 0@0.! !

!PacManGameActors methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:34'!
movement
	^myMovement.! !

!PacManGameActors methodsFor: 'as yet unclassified' stamp: 'Pablo 5/16/2012 20:55'!
position
	^myPosition.! !

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'Pablo 5/16/2012 19:40'!
blueGhost

	^BlueGhost new. ! !

!PacManTest methodsFor: 'movements' stamp: 'Pablo 5/16/2012 19:46'!
down

	^0@(-1).! !

!PacManTest methodsFor: 'construction block types' stamp: 'Pablo 5/16/2012 19:54'!
ghostHouseDoorType

	^GhostHouseDoorType new.! !

!PacManTest methodsFor: 'movements' stamp: 'Pablo 5/16/2012 19:43'!
left

	^-1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'Pablo 5/16/2012 19:57'!
leftTransporterType

	^LeftTransporterType new.! !

!PacManTest methodsFor: 'actors' stamp: 'Pablo 5/16/2012 19:47'!
pacman

	^PacMan new. ! !

!PacManTest methodsFor: 'movements' stamp: 'Pablo 5/16/2012 19:45'!
right

	^1@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'Pablo 5/16/2012 19:48'!
spaceType

	^SpaceType new. 
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'Pablo 5/16/2012 19:46'!
up

	^0@1.! !

!PacManTest methodsFor: 'construction block types' stamp: 'Pablo 5/16/2012 19:41'!
wallType

	^WallType new.! !
